/*
 * libtaskstats_snap - Snapshot library for easy access to taskstats interface
 *
 * Copyright IBM Corp. 2010
 * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
 */
#ifndef HELPER_H
#define HELPER_H

#include <errno.h>

#define ERR(x...) \
do { \
	fprintf(stderr, "%s: ", "tslib"); \
	fprintf(stderr, x); \
	fprintf(stderr, "\n"); \
} while (0)

#define ERR_EXIT(x...) \
do { \
	ERR(x); \
	exit(1); \
} while (0)

#define ERR_EXIT_ERRNO(x...) \
	do { \
		fflush(stdout); \
		fprintf(stderr, "%s: ", "tslib"); \
		fprintf(stderr, x); \
		fprintf(stderr, " (%s)", strerror(errno)); \
		fprintf(stderr, "\n"); \
		exit(1); \
	} while (0)

#define MIN(x, y) ((x) < (y) ? (x) : (y))

#endif
