/*
 * Test program for taskstats snapshot library
 *
 * Copyright IBM Corp. 2010
 * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "libtaskstats_snap.h"

#define ERR_EXIT(x...) \
	do { \
		fprintf(stderr, "ERROR: "); \
		fprintf(stderr, x); \
	} while (0);

static void l_snap_iter_print(struct ts_snap_iter *tss_i)
{
	struct taskstats *ts;

	do {
		ts = ts_snap_iter_next(tss_i);
		if (!ts)
			break;
		printf("%6i: %13llu %13llu %13llu %-10s\n", ts->ac_pid,
		       ts->ac_utime, ts->ac_stime, ts->ac_sttime, ts->ac_comm);
	} while (1);
}

int main(void)
{
	struct ts_snap_handle *tss_h;
	struct ts_snap_iter *tss_i;
	struct ts_snap *tss;

	tss_h = ts_snap_init(TS_SNAP_TASK_RUN);
	if (!tss_h)
		ERR_EXIT("snap init failed\n");

	while (1) {
		tss = ts_snap_next(tss_h);
		tss_i = ts_snap_iter_new(tss, TS_SNAP_TASK_RUN);
		if (!tss_i)
			ERR_EXIT("ts_snap_iter_new failed\n");
		l_snap_iter_print(tss_i);
		ts_snap_iter_free(tss_i);
		ts_snap_free(tss);
		sleep(2);
	}
	// ts_snap_exit(tss_h);
}
